package speller;
// code by jph

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.datatransfer.StringSelection;

import javax.swing.JDialog;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.WindowConstants;
import javax.swing.event.CaretEvent;
import javax.swing.event.CaretListener;

class TextDialog extends JDialog {
  
  JTextArea myJTextArea;
  
  TextDialog(Frame myFrame, StringBuffer myStringBuffer) {
    super(myFrame, "TextDialog", true);
    
    myJTextArea = new JTextArea(myStringBuffer.toString());
    //Manager.toolkit.getSystemClipboard().setContents(new StringSelection(myStringBuffer.toString()), null);
    myJTextArea.setOpaque(true);
    myJTextArea.setFont(new Font(Font.MONOSPACED, Font.BOLD, 11));
    myJTextArea.setForeground(Color.green);
    myJTextArea.setBackground(Color.black);
    //myJTextArea.setLineWrap(true);
    myJTextArea.setEditable(false);
    myJTextArea.addCaretListener(new CaretListener() {
      
      public void caretUpdate(CaretEvent myCaretEvent) {
        int lo = Math.min(myCaretEvent.getMark(), myCaretEvent.getDot());
        int hi = Math.max(myCaretEvent.getMark(), myCaretEvent.getDot());
        System.out.println(myCaretEvent);
        String myString = myJTextArea.getText().substring(lo, hi);
        System.out.println(myString);
        if (0 < myString.length())          
          Toolkit.getDefaultToolkit().getSystemClipboard().setContents(new StringSelection(String.format("\\u%04x", (int) myString.charAt(0))), null);
      }
    });
    
    Container myContainer = getContentPane();
    myContainer.setLayout(new BorderLayout());
    myContainer.add("Center", new JScrollPane(myJTextArea));
    
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    Dimension myDimension = new Dimension(Math.min(myJTextArea.getPreferredSize().width + 3 + 31, 800), Math.min(myJTextArea.getPreferredSize().height + 3 + 31 + 70, 600));
    Dimension myScreen = Toolkit.getDefaultToolkit().getScreenSize();
    Point myPoint = new Point((myScreen.width - myDimension.width) / 2, (myScreen.height - myDimension.height) / 2);
    setBounds(new Rectangle(myPoint, myDimension));
    setVisible(true);
  }
  
}
