function nu_main(varargin)
% code by jph

global nu user

if ~isstruct(user)
  disp('remark: specify user with nu_setup')
  return
end

if ~nargin
  error('remark: specify program, e.g. ''tabular''')
end

nuinit('nu')

nu.varargin=varargin;

close all

hnd=waitbar(0,'progress','name',mfilename,'Position',[1930 60 270 56.25]);

fprintf('program: %s\n',varargin{1})
eval(['run ' varargin{1}])

% BEGIN EVAL ----------------
col=cell(length(nu.events),1);
for c1=1:length(nu.events)
  col{c1}=nu.events{c1}.eval;
end
[u,U]=xunique(col);
for c1=1:length(u)
  fprintf('\t%s\t%i\n',u{c1},U(c1))
end
% END EVAL ----------------

nuhardware

if ~isempty(nu.events)
  fprintf('remark: total duration <a href="">%i</a> sec\n', ceil(nu.events{end}.toc))
end
fprintf('remark: to abort, press <a href="">Ctrl+C</a>, and type <a href="">nu_break</a>, or <a href="">nu_save</a>\n')

while ~nu.numel
  pause(0.05)
end

while nu.run
  if nu.case<size(nu.events,1)
    %disp(nu.numel)
    tim=toc;
    nu.pause=tim-nu.events{nu.case+1}.toc;                                 % TODO rename to .now with WeeLih
    if 0<nu.pause
      nu.case=nu.case+1;
      if 0.4<nu.pause
        fprintf(' time=%f  delay=%f  eval=%s\n',tim,nu.pause,nu.events{nu.case}.eval)
      end
      nu.events{nu.case}.now=tim; % TODO rename to .tic with WeeLih
      nu.events{nu.case}.mouse=get(0,'PointerLocation');
      nu.events{nu.case}.return=eval([nu.events{nu.case}.eval ';']);
      nu.events{nu.case}.toc_eval=toc;
      pause(eps) % update graphics
      nu.events{nu.case}.toc_pause=toc;
      try waitbar(tim/nu.events{end}.toc,hnd); catch end
    end
  else
    nu.run=0;
  end
  pause(eps)
  
end

try close(hnd); catch end

nu_break('nowarning')

if ~strcmp(user.title,'simulink')
  nu_save
end

nuget('report')
