% code by jph

function nuscalp(val,chn,varargin)

global nu

gry=[0.7 0.7 0.7];

map=repmat(NaN,[7 7]);
map(nu.inmem(chn))=val;

if all(ismember([1:4 19],chn))
  map(28)=mean(map([21 20 27 34 35]));
end

% mark unused channels
cmp=setdiff(1:41,chn);

% draw head ellipse
ang=linspace(0,2*pi,40);
hnd=plot(3*cos(ang),3.5*sin(ang),'k:');
set(hnd,'Color',gry)
hold on

%draw ears
hnd=plot(+[3.0 3.25],[0 -0.5],'k:');
set(hnd,'Color',gry)
hnd=plot(-[3.0 3.25],[0 -0.5],'k:');
set(hnd,'Color',gry)

plot(nu.grid(cmp,1),nu.grid(cmp,2),'xk');

axis equal
axis tight
axis off

% label the used channels
for c1=1:length(nu.text)
  hnd=text(nu.grid(c1,1),nu.grid(c1,2),nu.text{c1});
  set(hnd,'FontSize',8)
  set(hnd,'HorizontalAlignment','Center')
  if ismember(c1,chn)
    set(hnd,'Color',gry)
  else
    set(hnd,'Color','r')
  end
end

% overlay contour
warning('OFF','MATLAB:contour:NonFiniteData')
warning('OFF','MATLAB:contour:ConstantData')

contour(nu.x1,nu.x2,map);

warning('ON','MATLAB:contour:NonFiniteData')
warning('ON','MATLAB:contour:ConstantData')

hold off
