function val=prg_breakout(varargin)
% code by Per-Anders Ekstroem, jph

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin
    sec=600;
    nurun(0:0.05:sec ,'prg_breakout(''loop'')')
    nurun(sec        ,'prg_breakout(''stop'')')
    prg=0;
    warning('OFF','MATLAB:warn_r14_stucture_assignment')
    prg.width=400;
    warning('ON','MATLAB:warn_r14_stucture_assignment')
    prg.width=400;
    prg.height=300;
    prg.paddle.x=prg.width/4;
    prg.paddle.y=0;
    prg.ball.dx=0;
    prg.paddle.width =prg.width /6;
    prg.paddle.height=prg.height/20;
    prg.score.val=0;
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...
                      'Pointer','crosshair',...
                      'WindowButtonMotionFcn','nuevent(0,0,7)',... % only for simulink
                      'Color','k',...
                      'Colormap',[0 0 0;1 1 1],...
                      'Position',user.view);
    axes('Units','Normalized',...
      'Position',[0 0 1 1],...
      'Visible','off',...
      'DrawMode','fast');
    axis([0 prg.width 0 prg.height])
    prg.score.hnd=text(0,prg.height-prg.height/20,' Score: 0',...
      'FontName','FixedWidth',...
      'Color','w',...
      'FontWeight','Bold',...
      'FontUnits','normalized');      
    prg.campos.hnd=text(prg.width/2,prg.height/2,'x',...
      'EraseMode','normal',...
      'Color',[255 205 0]/300,...
      'FontUnits','normalized',...
      'FontSize',.020,...
      'Visible','on',...
      'HorizontalAlignment','Center',...
      'VerticalAlignment','Middle');      
    prg.ball.hnd=text(prg.width/2,prg.height/2,'\bullet',...
      'EraseMode','normal',...
      'Color','w',...
      'FontUnits','normalized',...
      'FontSize',.065,...%      'Visible','off',...
      'HorizontalAlignment','Center',...
      'VerticalAlignment','Middle');
    prg.paddle.hnd=rectangle('Position',[prg.paddle.x prg.paddle.y prg.paddle.width prg.paddle.height],...
      'FaceColor','m',...
      'EraseMode','background');
    prg.bricks=zeros(5,10);
    prg_breakout('NewBricks');    
    prg.now=[];  % buffers time           until eeg has arrived
    prg.ref=[];  % buffers mouse position until eeg has arrived      
    prg.campos.x=prg.width/2;
    prg.campos.y=prg.height/2;
    prg.ball.x=prg.width/2;
    prg.ball.y=prg.height/2;
    prg.ball.dx=5;
    prg.ball.dy=-5;
    prg.off=[0 0];
  else
    nu.run=0;
  end
else
  switch varargin{1}
  case 'loop'
    prg.toc=toc;
    val=[0.5 0.5];
    if nu.numel
      X=[nu.cell{nu.numel} ones(200,1)];
      sol=(median( X(end-60:end,user.eye.corrcoef{end}(:,1))*user.eye.corrcoef{end}(:,2:3) )+1 )/2;
      val=sol+prg.off;
      for c1=1:2
        if val(c1)<0
          prg.off(c1)=-sol(c1);
        end
        if 1<val(c1)
          prg.off(c1)=1-sol(c1);
        end
      end      
    end    
    prg.campos.x=min(max(0,val(1)),1)*prg.width;
    prg.campos.y=min(max(0,val(2)),1)*prg.height;
    set(prg.campos.hnd,'Position',[prg.campos.x prg.campos.y 0]);
    prg.paddle.x=min(max(0,val(1)),1)*prg.width-prg.paddle.width/2;
    set(prg.paddle.hnd,'Position',[prg.paddle.x prg.paddle.y prg.paddle.width prg.paddle.height])
    if prg.ball.x<0                        % reflect ball from left wall
      prg.ball.x=0;
      prg.ball.dx=-prg.ball.dx;
      soundsc(sin(1:100),5000)
    elseif prg.ball.x>prg.width            % reflect ball from right wall
      prg.ball.x=prg.width;
      prg.ball.dx=-prg.ball.dx;
      soundsc(sin(1:100),5000)
    end
    YPos=ceil(prg.ball.y/prg.height*20);
    switch YPos
      case 0                               % ball is down the drain
        if prg.ball.dy<0
          prg.ball.dy=-prg.ball.dy;
          col=get(prg.ball.hnd,'Color');   % color transports state information (bad coding)
          if col(2)
            set(prg.ball.hnd,'Color','r')  % color indicates that prg.bricks are deleted of kept
            prg.score.val = prg.score.val - 3;
          end
          soundsc(sin(1:100),2000)
        end
      case 1                               % ball in height of prg.paddle.hnd
        if prg.paddle.x<prg.ball.x & prg.ball.x<prg.paddle.x+prg.paddle.width
          prg.ball.dy=-prg.ball.dy;
          prg.ball.dx=(prg.ball.x-(prg.paddle.x+prg.paddle.width/2))/3;
          lim=2;
          if abs(prg.ball.dx)<lim
            prg.ball.dx=lim*sign(prg.ball.dx);
            if ~prg.ball.dx
              prg.ball.dx=lim;
            end
          end
          prg.ball.dx=min(max(-8,prg.ball.dx),8);
          set(prg.ball.hnd,'Color','w')
          soundsc(sin(1:100),5000)
        end
      case 21                              % ball hit ceiling
        prg.ball.dy = -prg.ball.dy;
        soundsc(sin(1:100),5000)
      case {18 17 16 15 14}                % ball in height of prg.bricks
        YPos=19-YPos;
        if ismember(YPos,[1 2 3 4 5])
          XPos=max(1,ceil(prg.ball.x/prg.width*10));
          if prg.bricks(YPos,XPos)
            col=get(prg.ball.hnd,'Color');
            if col(2)
              delete(prg.bricks(YPos,XPos))
              prg.bricks(YPos,XPos)=0;
              prg.score.val=prg.score.val+6-YPos;
            else
              prg.ball.dx=-prg.ball.dx;
            end
            prg.ball.dy=-prg.ball.dy;
            soundsc(sin(1:100),10000)
            if isempty(find(prg.bricks,1))
              prg_breakout('NewBricks');
            end
          end
        end
    end
    prg.ball.x=prg.ball.x+prg.ball.dx;
    prg.ball.y=prg.ball.y+prg.ball.dy;
    set(prg.ball.hnd,'Position',[prg.ball.x prg.ball.y])
    set(prg.score.hnd,'String',[
        ' Score: ' num2str(prg.score.val) ...
        ' :: ' sprintf('%6.3f ',prg.off)
      ])
  case 'NewBricks'
    delete(findobj(gcbf,'Tag','Bricks'))
    colors='rygcb';
    for i=1:5            
      for j=0:9
        prg.bricks(i,j+1)=rectangle(...
          'Position',[j*prg.width/10,prg.height-prg.height/20*(2+i),prg.width/10,prg.height/20],...
          'Tag','Bricks',...
          'FaceColor',colors(i));
      end
    end
  case 'stop'
    close(prg.figure);
  end
end
