function val=prg_eyelock(varargin)
%code by jph

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin
    sec=nuget('varargin.struct','sec',80);
    nurun(1:0.05:sec ,'prg_eyelock(''loop'')')
    nurun(sec        ,'prg_eyelock(''stop'')')
    %prg.help.figure=figure('Position',[1780 200 400 400])
    %prg.help.plot=plot(0,0);
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...
                      'Color',[0 0 0],...
                      'Pointer','crosshair',...
                      'WindowButtonMotionFcn','nuevent(0,0,7)',...
                      'WindowButtonDownFcn','nuevent(0,0,8)',...
                      'KeyPressFcn','nuevent(0,0,9)',... 
                      'Position',user.view);
    axes('Units','Normalized',...
      'Position',[0 0 1 1],...
      'Visible','off',...
      'DrawMode','fast');
    axis([0 user.view(3) 0 user.view(4)])
    fac=0.02;
    prg.text=text(user.view(3)*fac,user.view(4)*(1-fac),num2str(user.simulink.pause),...
      'FontName','FixedWidth',...
      'Color','w',...
      'FontWeight','Bold',...
      'FontUnits','normalized');
    prg.rectangle.cnt=0;
    prg.rectangle.hnd=rectangle('Position',[0 0 40 40],...
      'FaceColor',[0 0 0],...
      'EraseMode','background');
  else
    nu.run=0;
  end
else
  switch varargin{1}
    case {'loop','stop'}      
      if numel(nu.trace.print) | strcmp(varargin{1},'stop')
        num=nu.numel;
        idx=5:num;
        A=cell2mat(nu.cell(idx));
        
        chn=user.simulink.channel;
        fnd=find(all(A(:,chn)<1));
        chn=chn(fnd)';
        A=A(:,chn);
                
        ref_beg=nu.now{idx(1)-1}-user.simulink.pause;
        ref_end=nu.now{idx(end)}-user.simulink.pause;
        
        ind=1;
        for c1=numel(nu.trace.mouse):-1:1
          if nu.trace.mouse{c1}(1)<ref_beg
            ind=c1;
            break
          end
        end
        if ref_end<nu.trace.mouse{end}(1)
          mse=cell2mat(nu.trace.mouse(ind:end));
        else
          mse=cell2mat(vertcat(nu.trace.mouse(ind:end),[ref_end nu.trace.mouse{end}(2:end)]));
        end
        tim=linspace(ref_beg,ref_end,size(A,1))';
        pix=user.view(3)/2;
        piy=user.view(4)/2;
        msx=interp1(mse(:,1),(mse(:,2)-pix)/pix,tim,'linear');
        msy=interp1(mse(:,1),(mse(:,3)-piy)/piy,tim,'linear');
        b=[msx msy];
        if any(any(isnan(b)))
          disp('!!! NAN NAN !!!')
        end
        user.eye.corrcoef=vertcat( user.eye.corrcoef , [ [chn;41] [A ones(size(A,1),1)]\b ] );
        cmp=zeros(numel(chn),3);
        for c1=1:numel(chn)
          sol=[ [msx ones(size(A,1),1)]\A(:,c1) [msy ones(size(A,1),1)]\A(:,c1) ];
          cmp(c1,:)=[chn(c1) sol(1,:)];
        end
        user.eye.classdef=vertcat( user.eye.classdef , cmp );
        disp('terminate with')
        user.eye.corrcoef
        close(prg.figure)                
      else
        if ~mod(prg.rectangle.cnt,50)
          if prg.rectangle.cnt
            [res,hnd]=nuget('triggered.flash',prg.rectangle.toc);
            if ~isempty(res)
              set(prg.text,'String',num2str(res-prg.rectangle.toc))
              % set(prg.help.plot,'XData',hnd.XData-hnd.XData(1))
              % set(prg.help.plot,'YData',hnd.YData)
            end
          end
          prg.rectangle.toc=toc;
        end
        prg.rectangle.cnt=prg.rectangle.cnt+1;
        ron=1+(mod(prg.rectangle.cnt,50)<2);
        set(prg.rectangle.hnd,'FaceColor',repmat(ron-1,[1 3]))    
      end
    otherwise
      warning('unknown command')
  end
end
