function val=prg_impscan(varargin)
%code by jph

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin
    sec=nuget('varargin.struct','sec',240);
    nurun(1:0.05:sec  ,'prg_impscan(''loop'')')
    nurun(sec        ,'prg_impscan(''stop'')')
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...
                      'Color',[1 1 1],...
                      'WindowButtonMotionFcn','nuevent(0,0,7)',...
                      'WindowButtonDownFcn','nuevent(0,0,8)',...
                      'KeyPressFcn','nuevent(0,0,9)',... 
                      'Position',ceil(user.view/2));
    prg.numel=3;
    prg.sin=34;
    prg.cov=0;
    prg.imagesc=nuscalpi([1],[1]);
    prg.zeros=zeros(20,2);
    colorbar
    prg.run=0; % wait until first data arrives
  else
    nu.run=0;
  end
else
  switch varargin{1}
    case 'loop'
      prg.toc=toc;
      % if new data has arrived, modify plot
      if nu.pause<0.2
        val=1;
        if prg.numel<nu.numel
          prg.cov=0;
          val=2;
          prg.numel=nu.numel; % for thread safety store nu.numel into local variable
          X=nu.cell{prg.numel};
          chn=setdiff(find(all(X<1)),prg.sin);
          
            fX=fft(X);
            fq=[9:100];
            fX([1+fq end-fq+1],:)=0;
            X=ifft(fX);            
          
          ind=1:100;
          sol=[X(ind,prg.sin) ones(numel(ind),1) ]\X(ind,chn);  %linspace(0,1,200)'
          val=sol(1,:);
          prg.zeros=[ prg.zeros(2:end,:) ; [min(val) max(val)] ];
          
          nuscalpi([val min(prg.zeros(:,1)) max(prg.zeros(:,2))],[chn 35 37],prg.imagesc);
          title(num2str(prg.numel))
        else
          if ~prg.cov
            prg.cov=1;
            
            prg.numel=nu.numel; % for thread safety store nu.numel into local variable
            X=nu.cell{prg.numel};
            chn=setdiff(find(all(X<1)),prg.sin);
            
              fX=fft(X);
              fq=[9:100];
              fX([1+fq end-fq+1],:)=0;
              X=ifft(fX);            
            
            ind=101:200;
            sol=[X(ind,prg.sin) ones(numel(ind),1) ]\X(ind,chn);  %linspace(0,1,200)'
            val=sol(1,:);
            prg.zeros=[ prg.zeros(2:end,:) ; [min(val) max(val)] ];
            
            nuscalpi([val min(prg.zeros(:,1)) max(prg.zeros(:,2))],[chn 35 37],prg.imagesc);
            title(num2str(prg.numel+0.5))
            
          else
            % too quick
          end
        end          
      else          
        val=0; % software is lagging
      end      
    case 'stop'
      close(prg.figure)
    otherwise
      warning('unknown command')
  end
end
