function val=prg_tabular(varargin)
%code by jph

global nu user
persistent prg

val=[];

if isempty(findobj('type','figure','name',mfilename))
  if ~nargin
    sec=nuget('varargin.struct','sec',600);
    nurun(1:0.05:sec ,'prg_tabular(''loop'')')
    nurun(sec        ,'prg_tabular(''stop'')')
    prg.figure=figure('Name',mfilename,...
                      'Numbertitle','off',...
                      'Menubar','none',...
                      'Color',[1 1 1],...
                      'WindowButtonMotionFcn','nuevent(0,0,7)',...
                      'WindowButtonDownFcn','nuevent(0,0,8)',...
                      'KeyPressFcn','nuevent(0,0,9)',... 
                      'Position',user.view);
    prg.axes=subplot('Position',[0.05 0.05 0.9 0.9]);
    prg.run=0; % wait until first data arrives
  else
    nu.run=0;
  end
else
  switch varargin{1}
    case 'loop'
      if ~prg.run
        if nu.numel
          if length(nu.varargin)==1
            prg.cast=find(all(nu.cell{end}<1));
          else
            prg.cast=nu.varargin{2};
          end
          %prg.cast=[37 40 41];
          prg.length=2;                             % interval length [sec] for x axis range          
          prg.plot=zeros(1,length(prg.cast));       % preallocate space for plot handles    
          %prg.text=zeros(1,length(prg.cast));      % preallocate space for plot handles    
          prg.numel=nu.numel;                       % 0<nu.numel guaranteed by nu_main ! => that means ...
          prg.ydata=cell2mat(nu.cell(1:prg.numel)); % 200 * nu.numel  x   40    
          prg.xdata=[1:size(prg.ydata,1)]*0.001;    % sample to time [sec] conversion
          for c1=1:length(prg.cast)
            prg.plot(c1)=plot(0,0,'Color',nuget('color',c1));
            hold on      
          end
          prg.toc=toc;
          xlabel('[sec]')
          axis([prg.toc-prg.length prg.toc 0 length(prg.cast)+1])
          set(prg.axes,'YTick',1:length(prg.cast))
          set(prg.axes,'YTickLabel',nu.text(prg.cast))
          prg.legend=legend(nu.text(prg.cast),'Location','NorthWest');
        end
        prg.run=nu.numel;
      else
        prg.toc=toc;
        % if new data has arrived, modify plot
        if nu.pause<0.2
          val=1;
          if prg.numel<nu.numel
            val=2;
            num=nu.numel; % for thread safety store nu.numel into local variable
            % get data from eeg that has not been plotted before
            ydata=cell2mat(nu.cell(prg.numel+1:num)); % 200 * nu.numel  x   40   TODO check
            % ydata has the new eeg samples
            %ydata(:,26)=ydata(:,26)-ydata(:,25);
            
            fX=fft(ydata);
            fq=[9 10 11 20 30]; % 20 30
            fX(    fq+1,:) = 0;
            fX(end-fq+1,:) = 0;
            %
            ydata = ifft(fX);
            
            
            prg.xdata=[prg.xdata prg.numel*0.2+[1:size(ydata,1)]*0.001];  % sample to time [sec] conversion      
            prg.ydata=[prg.ydata;ydata];
            prg.numel=num; % update the data range that has been plotted
            %xdata=get(prg.plot(1),'XData');
            fnd=find( prg.toc-prg.length <= prg.xdata);
            prg.xdata=prg.xdata(fnd); % values in x-range that are in viewport
            prg.ydata=prg.ydata(fnd,:);
            prg.min= 1000;
            prg.max=-1000;
            col=cell(length(prg.cast),1);
            if ~mod(length(nu.trace.print),2)
              for c1=1:length(prg.cast)
                set(prg.plot(c1),'XData',prg.xdata)
                ydata=prg.ydata(:,prg.cast(c1))';
                alo=min(ydata);
                amp=max(ydata)-alo;
                ydata=ydata-(alo+amp*0.5);
                ydata=ydata*(1/(amp+1e-9))+c1; % TODO
                set(prg.plot(c1),'YData',ydata);
                col{c1}=sprintf('%s %f mV',nu.text{prg.cast(c1)},amp*1e3);
              end            
            end
            set(prg.legend,'String',col)
          end          
          if ~mod(length(nu.trace.print),2)
            axis(prg.axes,[prg.toc-prg.length prg.toc 0.5 length(prg.cast)+0.5]) % update the viewport
          end
        else          
          val=0; % software is lagging
        end
      end
    case 'stop'
      close(prg.figure)
    otherwise
      warning('unknown command')
  end
end
